"""Code generated by Speakeasy (https://speakeasy.com). DO NOT EDIT."""

from __future__ import annotations
from .chain import Chain
from .feeenum import FeeEnum
from .token_enum import TokenEnum
from compass_api_sdk.types import BaseModel
from typing import Optional, Union
from typing_extensions import NotRequired, TypeAliasType, TypedDict


UniswapSellExactlyRequestAmountInTypedDict = TypeAliasType(
    "UniswapSellExactlyRequestAmountInTypedDict", Union[float, str]
)
r"""The amount of the token to swap from"""


UniswapSellExactlyRequestAmountIn = TypeAliasType(
    "UniswapSellExactlyRequestAmountIn", Union[float, str]
)
r"""The amount of the token to swap from"""


UniswapSellExactlyRequestAmountOutMinimumTypedDict = TypeAliasType(
    "UniswapSellExactlyRequestAmountOutMinimumTypedDict", Union[float, str]
)
r"""The minimum amount of the token to swap to, defaults to 0"""


UniswapSellExactlyRequestAmountOutMinimum = TypeAliasType(
    "UniswapSellExactlyRequestAmountOutMinimum", Union[float, str]
)
r"""The minimum amount of the token to swap to, defaults to 0"""


class UniswapSellExactlyRequestTypedDict(TypedDict):
    r"""Request model for selling exactly an amount of tokens."""

    token_in: TokenEnum
    r"""A class representing the token.

    This class is used to represent the token in the system. Notice individual
    endpoints' documentation where per chain tokens are presented.
    """
    token_out: TokenEnum
    r"""A class representing the token.

    This class is used to represent the token in the system. Notice individual
    endpoints' documentation where per chain tokens are presented.
    """
    fee: FeeEnum
    r"""The transaction fee of a Uniswap pool in bips.

    Uniswap supports 4 different fee levels.
    """
    amount_in: UniswapSellExactlyRequestAmountInTypedDict
    r"""The amount of the token to swap from"""
    chain: Chain
    r"""The chain to use."""
    sender: str
    r"""The address of the transaction sender."""
    amount_out_minimum: NotRequired[UniswapSellExactlyRequestAmountOutMinimumTypedDict]
    r"""The minimum amount of the token to swap to, defaults to 0"""
    wrap_eth: NotRequired[bool]
    r"""Whether to wrap ETH to WETH, only use when swapping WETH into something"""


class UniswapSellExactlyRequest(BaseModel):
    r"""Request model for selling exactly an amount of tokens."""

    token_in: TokenEnum
    r"""A class representing the token.

    This class is used to represent the token in the system. Notice individual
    endpoints' documentation where per chain tokens are presented.
    """

    token_out: TokenEnum
    r"""A class representing the token.

    This class is used to represent the token in the system. Notice individual
    endpoints' documentation where per chain tokens are presented.
    """

    fee: FeeEnum
    r"""The transaction fee of a Uniswap pool in bips.

    Uniswap supports 4 different fee levels.
    """

    amount_in: UniswapSellExactlyRequestAmountIn
    r"""The amount of the token to swap from"""

    chain: Chain
    r"""The chain to use."""

    sender: str
    r"""The address of the transaction sender."""

    amount_out_minimum: Optional[UniswapSellExactlyRequestAmountOutMinimum] = None
    r"""The minimum amount of the token to swap to, defaults to 0"""

    wrap_eth: Optional[bool] = False
    r"""Whether to wrap ETH to WETH, only use when swapping WETH into something"""
